Home | History | Annotate | Download | only in move
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test11} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST11***************"
     29 tst_resm TINFO "move: slave subtree to slave parent."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of move/test11 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 	"${FS_BIND_ROOT}/bin/makedir" share dir
     44 	"${FS_BIND_ROOT}/bin/makedir" share parent2
     45 	"${FS_BIND_ROOT}/bin/makedir" share share2
     46 	"${FS_BIND_ROOT}/bin/makedir" share share1
     47 
     48 	mkdir dir/grandchild
     49 	mount --bind dir share1
     50 	"${FS_BIND_ROOT}/bin/makedir" slave dir
     51 	mkdir parent2/child2
     52 	mount --bind parent2 share2
     53 	"${FS_BIND_ROOT}/bin/makedir" slave parent2
     54 
     55 	mount --move dir parent2/child2
     56 	check -n parent2/child2 share2/child2
     57 
     58 	mount --bind "$disk1" share1/grandchild
     59 	check parent2/child2/grandchild share1/grandchild
     60 	check -n dir/grandchild/ parent2/child2/grandchild
     61 
     62 	mount --bind "$disk2" parent2/child2/grandchild/a
     63 	check -n share1/grandchild/a parent2/child2/grandchild/a
     64 
     65 
     66 	break
     67 done
     68 trap 'ERR=$? ; tst_resm TWARN "move/test11: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     69 if [ -n "${ERR_MSG}" ]; then
     70 	tst_resm TWARN "move/test11: ${ERR_MSG}"
     71 	ERR_MSG=""
     72 	result=$ERR
     73 fi
     74 trap '' ERR
     75 {
     76 	umount parent2/child2/grandchild/a
     77 	umount share1/grandchild
     78 	umount parent2/child2
     79 	umount dir # if move fails
     80 	umount share2
     81 	umount share1
     82 	umount share1
     83 	umount share2
     84 	umount parent2
     85 	umount dir
     86 
     87 	rm -rf dir parent* share*
     88 	cleanup
     89 } >& /dev/null
     90 if [ $result -ne 0 ]
     91 then
     92 	tst_resm TFAIL "move/test11: FAILED: move: slave subtree to slave parent."
     93 	exit 1
     94 else
     95 	tst_resm TPASS "move/test11: PASSED"
     96 	exit 0
     97 fi
     98 tst_exit
     99